{  12/07/95 v1.0   first official release to public }

{  12/10/95 v1.0a  fixed a minor bug in the Button2Click() routine to
                   Increment usage. The strTemp variable had a trialing space
                   included so the displayed Usage did not refresh correctly.}

{  12/12/95 v1.0b  Add a call to GetDeviceCaps() before starting the Print
                   routine to reset Font Height if the Default printer had
                   been changed and resulting PixelsPerInch value. Added
                   enhanced error reporting when user attempts to load a
                   32bit DLL using a 16bit application. <g> }

{  12/16/95 v1.0c  Added an additional Printer... option to the Main FILE Menu
                   which added PrinterSetupDialog and Printer FontDialog options.
                   Corrected a error in the Print routine which was trying to
                   adjust the Printer.Font instead of the Printer.Canvas.Font as
                   is required after executing Printer.BeginDoc. Added code to
                   allow the FormResize procedure to adjust for the Win95 TaskBar. }

{  12/28/95 v1.0d  Modified logic in StringGrid1DrawCell() to allow for complete
                   take over of DrawCell events without just redrawing over each
                   Cell as was done previously. This eliminates some of the redraw
                   flicker. }

{  01/05/96 v1.0e  I eliminated some of the redunduncy in the code by removing some
                   get methods that were not really required. I replaced the slow
                   Bubble Sort with a fast QuickSort procedure since I recieved a
                   comment about it from some other user. This was good because
                   now I have the methods down so I can use it later. }

unit Modmastu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Grids, Menus, ToolHelp, Printers,
  IniFiles, AboutBox;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveList1: TMenuItem;
    Print1: TMenuItem;
    Setup1: TMenuItem;
    Font1: TMenuItem;
    Exit1: TMenuItem;
    Module1: TMenuItem;
    All1: TMenuItem;
    Exe1: TMenuItem;
    Dll1: TMenuItem;
    VBX1: TMenuItem;
    DRV1: TMenuItem;
    FON1: TMenuItem;
    About1: TMenuItem;
    FontDialog1: TFontDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid1TopLeftChanged(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; NewCol, NewRow: Longint;
      var CanSelect: Boolean);
    procedure ModuleClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure SaveList1Click(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
  private
    { Private declarations }
    FType: integer;
    FColm: integer;
    FSize: integer;
    AllowForWin95TaskBar: boolean;
    procedure SetFSize(Value: integer);
    procedure SetColm(Value:integer);
    procedure SetFType(Value:integer);
    procedure ResetFormLocation;
    procedure AdjustLastColWidth;
    procedure SelectType;
    procedure SortGrid( const ColNum : integer );
    procedure QuickSort(L, R: Integer);
    procedure DecrementModuleUsage;
    function  FormatOutput(var n: integer): string;
  public
    { Public declarations }
    property Colm: integer read FColm write SetColm default 0;
    property PFontSize: integer read FSize write SetFSize default 12;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  ModTypes : array[0..5] of string[3] = ('*.*','EXE','DLL','VBX','DRV','FON');
  fsTextName: array[TFontStyle] of string[12] = ('fsBold','fsItalic',
                                                 'fsUnderline','fsStrikeOut');
  fpTextName: array[TFontPitch] of string[12] = ('fpDefault','fpVariable','fpFixed');
type
  CfType = function(var SG: TStringGrid; x,y: integer;var S): Integer;
var
  CFunc: CFType;

procedure TForm1.SetFSize(Value: integer);
begin
  if Value<>FSize then
    FSize := Value;
end;

procedure TForm1.SetColm(Value:integer);
begin
  if Value<>FColm then
    FColm := Value;
end;

procedure TForm1.SetFType(Value:integer);
begin
  if Value<>FType then
    FType := Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  TaskBarHandle: HWnd;
begin
  PFontSize := 12; { assume a default 12 point printer font size }
  AllowForWin95TaskBar := false;
  TaskBarHandle := FindWindow('Shell_TrayWnd',nil);      { Look for Win95 Taskbar handle }
  if TaskBarHandle > 0 then                 { We're running Win95 or WinNT w/Win95 shell }
    AllowForWin95TaskBar := true;

with StringGrid1 do
 begin
  Canvas.Font := Font;      { since I am doing the Drawing I need the setup infomation }
  { initialise column headings and set widths }
  Cells[0,0] := ' Module';
  ColWidths[0] := Canvas.TextWidth('X') * 9;      { 8 chars + 1 }

  Cells[1,0] := 'Usage';
  ColWidths[1] := Canvas.TextWidth(' Usage');      { should be small }

  Cells[2,0] := 'Size   ';
  ColWidths[2] := Canvas.TextWidth('8') * 9;      { very big number }

  Cells[3,0] := 'Date         Time    ';
  ColWidths[3] := Canvas.TextWidth('X') * 15;     { should be big enough }

  Cells[4,0] := ' Path & Filename';
  ColWidths[4] := Canvas.TextWidth('X') * 40;{ it will be recalculated later }

  { fire up the analysis }
  RowCount := 90;   { a large number as a attempt to stop flicker of redraw }
  Row := 1;
  SetColm(0);
  SetFType(0);
  All1.Checked := True;
 end;
end;

procedure TForm1.FormResize(Sender: TObject);
var
  bw,cw,tw: integer;
  FormRect: TRect;
  CxScreen,               { Width of screen in pixels }
  CyScreen,               { Height of screen in pixels }
  CxFullScreen,           { Width of client area in pixels }
  CyFullScreen,           { Heigth of client area in pixels }
  CyCaption:     Integer; { Height of a window's title bar in pixels }
  TaskBarHandle: HWnd;
  TaskBarCoord: TRect;
  MaximumCoord: TRect;
begin
  FormRect := BoundsRect;

  if AllowForWin95TaskBar then
    begin
      bw := Width - ClientWidth;
      TaskBarHandle := FindWindow('Shell_TrayWnd',nil);      { Look for Win95 Taskbar handle }
      GetWindowRect(TaskBarHandle,TaskBarCoord);          { Get coordinates of Win95 Taskbar }
      CxScreen      := GetSystemMetrics(SM_CXSCREEN);    { Get various screen dimensions }
      CyScreen      := GetSystemMetrics(SM_CYSCREEN);       {and set form's width/height }
      CxFullScreen  := GetSystemMetrics(SM_CXFULLSCREEN);
      CyFullScreen  := GetSystemMetrics(SM_CYFULLSCREEN);
      CyCaption     := GetSystemMetrics(SM_CYCAPTION);
      with MaximumCoord do
      begin
        Right  := CxScreen+1;
        Bottom := CyScreen+1;
        Top    := 0;
        Left   := 0;                                      { Taskbar on either top or left }
        if (TaskBarCoord.Top<=0) and (TaskBarCoord.Left<=0) then
          if TaskBarCoord.Right > TaskBarCoord.Bottom then
            Top    := TaskBarCoord.Bottom                { Taskbar on top }
          else
            Left   := TaskBarCoord.Right                 { Taskbar on left }
        else
          if (TaskBarCoord.Top<=0) then
            Right  := TaskBarCoord.Left                  { TaskBar on Right }
          else
            Bottom := TaskBarCoord.Top;                  { Taskbar on Bottom }

        if (FormRect.Bottom-FormRect.Top)>(Bottom-Top) then { must shrink the Form Height }
          FormRect.Bottom := FormRect.Top + (Bottom-Top);
        if (FormRect.Right-FormRect.Left)>(Right-Left) then { must shrink the Form Width }
          FormRect.Right := FormRect.Left + (Right-Left);

        if WindowState=wsMaximized then
          FormRect := MaximumCoord
        else
          begin
            while (FormRect.Top<MaximumCoord.Top) do              { slide the Form Down }
              begin
                inc(FormRect.Top);
                if FormRect.Bottom<MaximumCoord.Bottom then
                  inc(FormRect.Bottom);
              end;
            while (FormRect.Left<MaximumCoord.Left) do            { slide the Form Right }
              begin
                inc(FormRect.Left);
                if FormRect.Right<MaximumCoord.Right then
                  inc(FormRect.Right);
              end;
            while (FormRect.Bottom>MaximumCoord.Bottom) do
              begin                                               { slide the Form Up }
                if FormRect.Top>MaximumCoord.Top then
                  dec(FormRect.Top);
                dec(FormRect.Bottom);
              end;
            while (FormRect.Right>MaximumCoord.Right) do
              begin
                if (FormRect.Left>MaximumCoord.Left) then         { slide the Form Left }
                  Dec(FormRect.Left);
                Dec(FormRect.Right);
              end;
          end;
      end;
      BoundsRect := FormRect;
    end;

  with FormRect do
    cw := Right - Left;
  with Button2 do
    Left := (cw - Width) div 2;
  with Button5 do
    Left := (cw - Width) div 2;
  with Button3 do
    Left := cw - Width - 18;
  with Button6 do
    Left := cw - Width - 18;
  AdjustLastColWidth;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const
  working : boolean = false;
begin
  if (ssAlt in Shift) then
   if (char(Key) in ['D','R','U','P','L','I','X']) then
     begin
       if not(working) then
         begin
           working := true;
           case lo(Key) of
             ord('D'): Button5Click(Sender);       { ALT_D }
             ord('R'): Button6Click(Sender);       { ALT_R }
             ord('U'): Button4Click(Sender);       { ALT_U }
             ord('P'): Button3Click(Sender);       { ALT_P }
             ord('L'): Button1Click(Sender);       { ALT_L }
             ord('I'): Button2Click(Sender);       { ALT_I }
             ord('X'): Exit1Click(Sender);         { ALT_X }
           end;
           working := false;
         end;
       key := 0;
     end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ResetFormLocation;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  SelectType;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Sysini: TIniFile;
  TFPitch: TFontPitch;
  TFStyle: TFontStyle;
  FString: String;
begin
  try
    Sysini := TInifile.Create(ChangeFileExt(paramstr(0),'.INI'));
    try
     with Form1,Sysini do
      begin
        WriteInteger('TMWCFG','MFTop',Top);
        WriteInteger('TMWCFG','MFLeft',Left);
        WriteInteger('TMWCFG','MFWidth',Width);
        WriteInteger('TMWCFG','MFHeight',Height);
        case WindowState of
          wsMinimized:  WriteInteger('TMWCFG','WinState', 1);
          wsNormal:     WriteInteger('TMWCFG','WinState', 2);
          wsMaximized:  WriteInteger('TMWCFG','WinState', 3);
        end;

        WriteString ('TPRTCFG','TPRTFN',Printer.Canvas.Font.Name);
        WriteInteger('TPRTCFG','TPRTFZ',PFontSize);

        FString := '';
        for TFStyle := fsBold to fsStrikeOut do
         if TFStyle in Printer.Canvas.Font.Style then
          Fstring := Fstring+fsTextName[TFStyle]+',';
        if FString<>'' then
          dec(FString[0]);
        FString := FString + '          ;'; { add comments of TFont style to choose from }
        for TFStyle := fsBold to fsStrikeOut do
          Fstring := Fstring+fsTextName[TFStyle]+',';
        dec(FString[0]);
        WriteString ('TPRTCFG','TPRTFS',FString);

        FString := fpTextName[Printer.Canvas.Font.Pitch]+' ;';
        for TFpitch := fpDefault to fpFixed do
          FString := FString + fpTextName[TFpitch]+',';
        dec(FString[0]);
        WriteString('TPRTCFG','TPRTFP',FString);
      end;
    finally
      Sysini.Free;
    end;
  finally
    Action := caFree;
  end;
end;

procedure TForm1.ResetFormLocation;
var
  TFPitch: TFontPitch;
  TFStyle: TFontStyle;
  LFStyle: TFontStyles;
  FString: String[60];
  Sysini: TInifile;
  l,t,w,h,n: integer;
begin
  try
    Sysini := TInifile.Create(ChangeFileExt(paramstr(0),'.INI'));
    with Form1 do
      begin
        l := left;
        t := top;
        h := height;
        w := width;
        case WindowState of
          wsMinimized: n := 1;
          wsNormal:    n := 2;
          wsMaximized: n := 3;
        end;
      end;

    with Sysini do
      begin
        t := ReadInteger('TMWCFG','MFTop',t);
        l := ReadInteger('TMWCFG','MFLeft',l);
        w := ReadInteger('TMWCFG','MFWidth',w);
        h := ReadInteger('TMWCFG','MFHeight',h);
        n := ReadInteger('TMWCFG','WinState',n);
      end;

    with Screen do   { Range check input values }
      begin
        if (h<50)or(h>Height) then
          begin h := Height-50; t := 25; end;
        if (w<50)or(w>Width) then
          begin w := Width-50;  l := 25; end;
        if (t<0)or(t>h) then    t := 25;
        if (l<0)or(l>w) then    l := 25;
      end;

    with Form1 do
      begin
        SetBounds(l,t,w,h);
        case n of
          1: WindowState := wsMinimized;
          2: WindowState := wsNormal;
          3: WindowState := wsMaximized;
        end;
      end;

    with Sysini, Printer.Canvas.Font do
      begin
        Name      := ReadString ('TPRTCFG','TPRTFN','Courier New');
        PFontSize := ReadInteger('TPRTCFG','TPRTFZ', PFontSize);

        FString   := ReadString ('TPRTCFG','TPRTFS','');
        if pos(';',FString)>0 then { strip comments of TFont styles off end }
          FString := Copy(FString,1,pos(';',FString)-1);
        LFStyle := [];
        for TFStyle := fsBold to fsStrikeOut do
         if (pos(fsTextName[TFStyle],FString)>0) then
          LFStyle := LFstyle + [TFStyle];
        Style := LFStyle;

        Fstring := fpTextName[Pitch];
        FString := ReadString('TPRTCFG','TPRTFP',FString);
        if pos(';',FString)>0 then
          FString := Copy(FString,1,pos(';',FString)-1);
        for TFPitch := fpDefault to fpFixed do
         if (pos(fpTextName[TFPitch],FString)>0) then
          Pitch := TFPitch;
     end;
  finally
    Sysini.free;
  end;
end;

procedure TForm1.AdjustLastColWidth;
var
  c, i, tw, sw, cw: integer;
begin
 with StringGrid1 do
   begin
     cw := ClientWidth;
     sw := 0;
     for i := 0 to RowCount-1 do           { find the minimum display width }
      begin                                { of the last column of filenames }
       tw := Canvas.TextWidth(Cells[4,i]); { by checking the textwidth of the }
       if tw>sw then sw := tw;             { current Font being used. }
      end;
     i := ColCount-1;
     tw := sw;
     while (i>0) and (tw<cw) do           { add in the width of others columns}
       begin                           { until it is greather than Clientwidth}
         dec(i);
         tw := tw + ColWidths[i] + GridLineWidth;
       end;
     if tw>cw then                     { if we added in too much then subtract}
       begin
         tw := tw - ColWidths[i] - GridLineWidth; { it back out }
         StringGrid1.Scrollbars := ssBoth;
       end;
     if tw<>cw then
       sw := sw + cw - tw - 1;
     ColWidths[4] := sw;
   end;
end;

procedure TForm1.SelectType;

var
  strTemp    : String[8];
  strName    : String[8];
  strExePath : string[120];
  Module     : TModuleEntry;
  FSearchrec : TSearchRec;
  FindResult : integer;
  f, i, w    : integer;

begin { TForm1.SelectTypeClick }
    { clear the grid }
  Screen.Cursor := crHourGlass;
  Application.Processmessages;
  with StringGrid1 do
   begin
    for i := 0 to 4 do
      Cols[i].BeginUpdate;
    Row := 1;
    Cells[0,1] := '';
    Cells[1,1] := '';
    Cells[2,1] := '';
    Cells[3,1] := '';
    Cells[4,1] := '';
   end;
  i := 1;
  w := 0;
  f := Ftype;
  Module.dwSize := SizeOf(Module);

  if ModuleFirst(@Module) then
    repeat
      strName := StrPas(Module.szModule);
      strExePath := strpas(Module.szExepath);
      if length(strExePath)>w then
        w := length(strExePath);
      FindResult := FindFirst(strExePath, faAnyFile, FSearchRec);
      strTemp := Copy(strExepath, length(strExepath)-2,3);
      if (f=0) or (uppercase(strTemp) = ModTypes[f]) and (strName<>'') then
       with StringGrid1 do
        begin
          if i=RowCount then
            RowCount   := i+1;
          Cells[0,i] := ' '+strName;
          Cells[1,i] := FormatFloat('## ',Module.wUsageFlags);
          Cells[2,i] := FormatFloat('###,###,##0 ',FSearchrec.size);
          Cells[3,i] := FormatDateTime( 'm/dd/yyyy  hh:nn:ss ',
                                                     FileDateToDateTime(FSearchRec.Time));
          Objects[2,i] := pointer(FSearchrec.size);
          Objects[1,i] := pointer(Module.wUsageFlags);
          Objects[3,i] := pointer(FSearchRec.Time);
          Cells[4,i] := ' '+strExePath;
          Inc( i );
        end;
    until ModuleNext(@Module)=false;
  with StringGrid1 do
   begin
    if i>2 then
      RowCount := i
    else
      RowCount := 2;
     if i=1 then
       Cells[0,1] := '(none)';
   end;
  AdjustLastColWidth;
  SortGrid(FColm);
  for i := 0 to 4 do
    StringGrid1.Cols[i].EndUpdate;
  Screen.Cursor := crDefault;
  Form1.Invalidate;
end; { TForm1.SelectType }


{ NOTE: These next (2) function must be FAR and cannot be
        declared as part of the default object TFORM1.     }

function CompareCellTxt(var SG: TStringGrid; x,y: integer;var S): Integer; far;
type Sptr = ^String;
begin
  Result := AnsiCompareText(SG.Cells[x,y],Sptr(S)^);
end;

function CompareLongInt(var SG: TStringGrid; x,y: integer;var s): Integer; far;
begin
  if longint(SG.Objects[x,y]) > longint(S) then
    Result := 1
  else
    if longint(SG.Objects[x,y]) = longint(S) then
      Result := 0
    else
      Result := -1;
end;

procedure TForm1.QuickSort(L, R: Integer);
var
  C, I, J: Integer;
  P1: Pointer;
  S2: String;
begin
 with StringGrid1 do
  begin
   I := L;
   J := R;
   S2 := Cells[Colm,(L + R) shr 1];
   if (Colm=1)or(Colm=2)or(Colm=3) then
     P1 := Objects[Colm,(L + R) shr 1]
   else
     P1 := @S2;
   repeat
     while CFunc(StringGrid1,Colm,I,P1) < 0 do Inc(I);
     while CFunc(StringGrid1,Colm,J,P1) > 0 do Dec(J);
     if I <= J then
     begin
       for C := 0 to ColCount-1 do
         Cols[C].Exchange(I,J);
       Inc(I);
       Dec(J);
     end;
   until I > J;
  end;
  if L < J then QuickSort(L, J);
  if I < R then QuickSort(I, R);
end;

procedure TForm1.SortGrid( const ColNum : integer );
var
  I: Integer;
begin { TForm1.SortGrid }
   SetColm(ColNum);
   if (Colnum=1)or(Colnum=2)or(Colnum=3) then
     CFunc := CompareLongint
   else
     CFunc := CompareCellTxt;
   with StringGrid1 do
     begin
       QuickSort(FixedRows,RowCount-1);
       SetFocus;
     end;
end; { TForm1.SortGrid }

procedure TForm1.StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
var
  c, r : longint;
begin

  if (Button = mbLeft) and (Shift = [ssLeft]) then
   with StringGrid1 do
    begin
      MouseToCell( X, Y, c, r );
      if (X>0)and(X<Width)and(Y>0)and(Y<StringGrid1.Height) then
       if (r = 0) and (FColm<>c) then
        begin
          Screen.Cursor := crHourGlass;
          Application.Processmessages;
          for r := 0 to ColCount-1 do
            StringGrid1.Cols[r].BeginUpdate;
          SortGrid( c );
          for r := 0 to ColCount-1 do
            StringGrid1.Cols[r].EndUpdate;
          Screen.Cursor := crDefault;
        end;
    end;
end;

procedure TForm1.StringGrid1TopLeftChanged(Sender: TObject);
begin
 with StringGrid1 do
  begin
    if (Row<TopRow) or (Row>TopRow+VisibleRowCount) then
      begin
        Button2.Enabled := false;
        Button5.Enabled := false;
      end
    else
      begin
        Button2.Enabled := true;
        Button5.Enabled := true;
      end;
    if Row<TopRow then
      if TopRow-Row>2 then
        Row := TopRow + 1
      else
        Row := TopRow
    else
      if Row>(TopRow+VisibleRowCount-1) then
        if TopRow+VisibleRowCount-Row>2 then
          Row := TopRow+VisibleRowCount-3
        else
          Row := TopRow+VisibleRowCount-2;
  end;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; NewCol, NewRow: Longint;
                                                        var CanSelect: Boolean);
begin
 with StringGrid1 do
  if (Cells[0,1]<>'(none)')and(pos('.DLL',UpperCase(Cells[4,NewRow]))>0) then
    begin
      Button2.Enabled := true;
      Button4.Enabled := true;
      Button5.Enabled := true;
    end
  else
    begin
      Button2.Enabled := false;
      Button4.Enabled := false;
      Button5.Enabled := false;
    end;
end;

procedure TForm1.DecrementModuleUsage;
var
  strTemp    : String[12];
  Module     : TModuleEntry;
  ecode      : integer;
  Done       : boolean;

  procedure UpdateModuleVariable;
  begin
   if ModuleFirst(@Module) then
    while (not(Done) and (strTemp<>StrPas(Module.szModule))) do
     begin
      Application.Processmessages;
      Done := ModuleNext(@Module)=false;
     end;
  end;

begin
 with StringGrid1 do
  begin
   strTemp := Cells[0,Row];
   while (strTemp[1]=' ')and(strTemp<>'') do
     delete(strTemp,1,1);
   fillchar(Module,sizeof(Module),0);
   Module.dwSize := Sizeof(Module);
   Done := false;

   UpdateModuleVariable;
   if (strTemp=StrPas(Module.szModule)) then
     FreeLibrary(Module.hModule);
   UpdateModuleVariable;

   if (strTemp=StrPas(Module.szModule)) then
     begin
       Cells[1,Row] := FormatFloat('## ', Module.wUsageFlags);
       Objects[1,Row] := pointer(Module.wUsageFlags);
     end
   else
     SelectType;
  end;
end;

procedure Report_LoadLibraryError(var hHND: THandle);
var
  es: string;
begin
  case hHND of
    0:  es := 'System was out of memory, executable file was corrupt, or relocations '+
              'were invalid.';
    2:  es := 'File was not found.';
    3:  es := 'Path was not found.';
    5:  es := 'Attempt was made to dynamically link to a task, or there was a sharing '+
              'or network-protection error.';
    6:  es := 'Library required separate data segments for each task.';
    8:  es := 'There was insufficient memory to start the application.';
   10:  es := 'Windows version was incorrect.';
   11:  es := 'Executable file was invalid. Either it was not a Windows application '+
              'or there was an error in the .EXE image.';
   12:  es := 'Application was designed for a different operating system.';
   13:  es := 'Application was designed for MS-DOS 4.0.';
   14:  es := 'Type of executable file was unknown.';
   15:  es := 'Attempt was made to load a real-mode application (developed for an '+
              'earlier version of Windows).';
   16:  es := 'Attempt was made to load a second instance of an executable file'+
              'containing multiple data segments that were not marked read-only.';
   19:  es := 'Attempt was made to load a compressed executable file. The file must be '+
              'decompressed before it can be loaded.';
   20:  es := 'Dynamic-link library (DLL) file was invalid. One of the DLLs required to '+
              'run this application was corrupt.';
   21:  es := 'Application requires 32-bit extensions.';
  else  es := 'An unknown error has occurred..';
  end; { Case of }
  if MessageDlg(es,mtInformation,[mbCancel],0)=0 then;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  OpenDialog: TOpenDialog;
  hHND: THandle;
  pFileName: array[0..120] of char;
begin
  OpenDialog:= TOpenDialog.Create(Self);
  with OpenDialog do
    begin
      Filter := 'DLL Files|*.DLL';
      DefaultExt := 'DLL';
      Options := [ofFileMustExist,ofPathMustExist];
      if Execute then
        begin
          StrPCopy(pFileName,Filename);
          hHND := LoadLibrary(pFileName);
          if hHND>HINSTANCE_ERROR then
            SelectType
          else
            Report_LoadLibraryError(hHND);
        end;
    end;
  OpenDialog.Free;
end;

procedure TForm1.Button2Click(Sender: TObject); { Increment Usage }
var
  strTemp : string[12];
  Module  : TModuleEntry;
  hHND: THandle;
  pFileName : array[0..120] of char;
  Done : boolean;
begin
 with StringGrid1 do
  begin
    Done := false;
    fillchar(Module,sizeof(Module),0);
    Module.dwSize := Sizeof(Module);
    strTemp := Cells[0,Row];
    StrPcopy(pFileName,Cells[4,Row]);
    hHND := LoadLibrary(pFileName);
    if hHND>HINSTANCE_ERROR then
      begin
        strTemp := Cells[0,Row];
        while (pos(' ',strTemp)>0) do
          delete(strTemp,pos(' ',strTemp),1);
        if ModuleFirst(@Module) then
         while not(Done)
          and (strTemp<>StrPas(Module.szModule)) do
           Done := ModuleNext(@Module)=false;
         if strTemp=StrPas(Module.szModule) then
           begin
             Cells[1,Row] := FormatFloat('## ', Module.wUsageFlags);
             Objects[1,Row] := pointer(Module.wUsageFlags);
           end;
      end
    else
      Report_LoadLibraryError(hHND);
  end;
end;

function PadStr(const S: String;const w: integer): string;
begin
  Result := S;
  while length(Result)<w do
    Result:= ' '+Result;
end;

function  TForm1.FormatOutput(var n: integer): string;
var
  w : integer;
  trec: string[120];
begin
 with StringGrid1 do
  begin
   w := 45 + length(Cells[4,n]);
   Result := Padstr(' ',w);
   TRec := Cells[0,n];                  { module name }
   move(TRec[2],Result[ 1],length(Trec)-1);
   TRec := Padstr(Cells[1,n],3);        { usage }
   move(TRec[1],Result[10],length(Trec));
   TRec := PadStr(Cells[2,n],10);       { file size }
   move(TRec[1],Result[13],length(Trec));
   TRec := PadStr(Cells[3,n],21);       { date & time }
   move(TRec[1],Result[24],length(Trec));
   TRec := Cells[4,n];                  { d:\path\filename }
   move(TRec[1],Result[45],length(Trec));
  end;
end;

function PrintedListHeading(const n:integer): string;
begin
  if n =1 then
    Result := 'MODULE  USAGE   SIZE      DATE       TIME        PATH & FILE NAME'
  else
    Result := '-----------------------------------------------------------------';
end;

procedure TForm1.Button3Click(Sender: TObject); { Print List }
const
  working : boolean = false;
var
  s, p, h, i: integer;
  cpage: integer;
begin
  with StringGrid1 do
   if (Cells[0,Row]='(none)') then
    begin
      MessageBeep(0);
      exit;
    end;
  if working then exit;
  working := true;
  Button3.Enabled := false;
  Screen.Cursor := crHourGlass;
  Application.Processmessages;
  Printer.BeginDoc;
  with Printer.Canvas do
   begin
    p := 0;
    i := 1;
    cpage := 0;
    Font.PixelsPerInch := GetDeviceCaps ( Handle, LOGPIXELSY);
    Font.Size := PFontSize;
    h := abs(Font.Height);
    Brush.Style := bsClear;
    Printer.Title := 'MODMASTR v1.0 Report file';
    while (i<StringGrid1.RowCount)and(not(Printer.Aborted)) do
      begin
        if ((i mod 58)=1) then { 58 lines of text + 2 of headings }
          begin
            if (cpage>0) then
              p := Printer.PageHeight * cpage;
            TextOut(0,p,PrintedListHeading(1));
            inc(p,h);
            TextOut(0,p,PrintedListHeading(2));
            inc(p,h);
            inc(cpage);
          end;
        TextOut(0,p,FormatOutput(i));
        inc(p,h);
        inc(i);
      end;
   end;
  Printer.EndDoc;
  working := false;
  Button3.Enabled := true;
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button4Click(Sender: TObject); { UnLoad DLL }
var
  strTemp : string[12];
  ModType : string[3];
begin
 with StringGrid1 do
  if (Cells[0,Row]<>'(none)') then
    begin
      strTemp := Cells[0,Row];
      ModType := copy(Cells[4,Row],length(Cells[4,Row])-2,3);
      if MessageDLG('Are you sure you want to '#13+
                    ' UnLoad - '+strTemp+'.'+ModType,
                                        mtConfirmation,[mbYes,mbNo],0) = mrYes then
        while (strTemp=Cells[0,Row]) do
          DecrementModuleUsage;
    end
  else
    MessageBeep(0);
end;

procedure TForm1.Button5Click(Sender: TObject); { Decrement Usage }
var
  strTemp    : String[12];
  ModType    : String[3];
begin
 with StringGrid1 do
  if (Cells[0,Row]<>'(none)') then
    begin
      strTemp := Cells[0,Row];
      ModType := copy(Cells[4,Row],length(Cells[4,Row])-2,3);
      if MessageDLG('Are you sure you want to Decrement'#13+
                    ' the Usage of Module - '+strTemp+'.'+ModType,
                                        mtConfirmation,[mbYes,mbNo],0) = mrYes then
        DecrementModuleUsage;
    end
  else
    MessageBeep(0);
end;

procedure TForm1.Button6Click(Sender: TObject); { Refresh List }
begin
  SelectType;
end;

procedure TForm1.ModuleClick(Sender: TObject);
var
  T: integer;
begin
  with (Sender as TMenuItem) do
   if FType<>Tag then
    begin
      All1.Checked := false;
      Exe1.Checked := false;
      Dll1.Checked := false;
      VBX1.Checked := false;
      DRV1.Checked := false;
      FON1.Checked := false;
      Checked := true;
      SetFType(Tag);
      SelectType;
    end;
end;

procedure TForm1.SaveList1Click(Sender: TObject);
var
  OpenDialog: TOpenDialog;
  SaveFile: TextFile;
  pRec: String;
  tRec: String[120];
  i, w: integer;
begin
 with StringGrid1 do
  if (Cells[0,Row]<>'(none)') then
   begin
    OpenDialog:= TOpenDialog.Create(Self);
    with OpenDialog do
      begin
        Title  := 'Save Module List';
        Options :=[ofHideReadOnly];
        Filter := 'Report File (*.RPT)|*.RPT|Text File (*.TXT)|*.TXT|All Files (*.*)|*.*';
        FileName := ChangeFileExt(paramstr(0),'.RPT');
        DefaultExt := 'RPT';
        if Execute then
          begin
            AssignFile(SaveFile,Filename);
            rewrite(SaveFile);
            writeln(SaveFile,PrintedListHeading(1));
            writeln(SaveFile,PrintedListHeading(2));
            for i := 1 to RowCount-1 do
              writeln(SaveFile,FormatOutput(i));
            CloseFile(SaveFile);
          end;
      end;
    OpenDialog.Free;
   end
  else
   MessageBeep(0);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutForm := TAboutForm.Create(Application);
  try
    AboutForm.ShowModal;
  finally
    AboutForm.Free;
  end;
end;

procedure TForm1.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (lo(Key)=VK_LEFT)
  or (lo(Key)=VK_RIGHT) then
   with StringGrid1 do
    begin
      if lo(Key)=VK_LEFT then      { Left Arrow }
        if LeftCol>0 then
          LeftCol := LeftCol -1
        else
      else                         { Right Arrow }
        if LeftCol+VisibleColCount<5 then
          LeftCol := LeftCol +1;
      Key := 0;
    end;
end;

procedure TForm1.StringGrid1DrawCell(Sender:TObject; Col,Row:Longint;
  Rect: TRect; State: TGridDrawState);
var lRow, lCol : Longint;
begin
    lRow := Row;
    lCol := Col;
    with (Sender as TStringGrid) do
     with Canvas do
      begin
       Font.Color := (Sender as TStringGrid).Font.Color;
       if (gdSelected in State) then
         begin
           Brush.Color := clHighlight;
           Font.Color  := clHighlightText;
         end
       else
         if (gdFixed in State) then
           Brush.Color := StringGrid1.FixedColor
         else
           Brush.Color := StringGrid1.Color;
       FillRect(Rect);
       SetBkMode(Handle, TRANSPARENT);
       if ((lCol>0)and(lCol<4)) then
         begin
           SetTextAlign(Handle, TA_RIGHT);
           TextOut(Rect.Right-2, Rect.Top+2, Cells[lCol, lRow]);
         end
       else
         begin
           SetTextAlign(Handle, TA_LEFT);
           TextOut(Rect.Left+2, Rect.Top+2, Cells[lCol, lRow]);
         end;
      end;
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.execute;
end;

procedure TForm1.Font1Click(Sender: TObject);
begin
 with FontDialog1 do
  begin
    Font := Printer.Canvas.Font;
    Font.Size := PFontSize;
    Options := [fdTrueTypeOnly];
    if Execute then
      begin
        Printer.Canvas.Font := Font;
        PFontSize := Font.Size;
      end;
  end;
end;

end.


